/***************************************************************************
                          canimatedaction.h  -  description
                             -------------------
    begin                : Tue Nov 15 17:03:53 CET 2005
    copyright            : (C) 2005 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CANIMATEDACTION_H
#define CANIMATEDACTION_H

#include <kaction.h>
#include <qtimer.h>
#include <qlabel.h>

/** Provide a little animation of the icons
  * @author Eric Coquelle
  */
class CAnimatedAction : public KAction
{
Q_OBJECT
public:
    CAnimatedAction(const QString &text, const QString &pix, const KShortcut &cut, const QObject *receiver, const char *slot, KActionCollection *parent, const char *name);
    CAnimatedAction(QObject *parent = 0, const char *name = 0);

    ~CAnimatedAction();

public slots:
    /** Prepare the animation of the icons, provided the toolbar is active*/
    void slotStartAnimation(bool);
private slots:
    /** Start the animation of the icons*/
    void slotDoAnimation();
    
private:
    QTimer timericons;
    QString iconname;
    QStringList iconslist;
    unsigned int currenticon;
};

#endif
