/***************************************************************************
                          resource.h  -  description
                             -------------------
    begin                : mer jun 14 00:26:31 CEST 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef RESOURCE_H
#define RESOURCE_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

///////////////////////////////////////////////////////////////////
// resource.h  -- contains macros used for commands


///////////////////////////////////////////////////////////////////
// General application values
#define ID_STATUS_MSG               1001

#define IDS_STATUS_DEFAULT          "Ready"

#define EXTRACT_ALL_FILES        0
#define EXTRACT_SELECTED_FILES   1
#define EXTRACTONE               8
#define EXTRACTONE_AND_BLOCK     9
#define EXTRACT_AND_OVERWRITE    10

#define ADD_AND_REPLACE_FILES 0
#define UPDATE_FILES 1

#define STANDARD_DATE          0
#define LOCALISED_DATE         1
#define LOCALISED_FULL_DATE    2

#define CONVERSION_ACHIEVED                 0
#define CANNOT_PERFORM_OPERATION            1
#define DISPLAY_ACHIEVED                    2
#define EXTRACT_ACHIEVED                    3
#define MULTI_EXTRACTION_ACHIEVED           4
#define SFX_ARCHIVE_CREATED                 5
#define VIEW_FILES_ACHIEVED                 6
#define ADD_FILES_ACHIEVED                  7
#define ARCHIVE_CREATION_ACHIEVED           8
#define TEST_ACHIEVED                       9
#define ADD_FILES_ANOTHER_ARCHIVE_ACHIEVED 10
#define CREATE_ARCHIVE_CMD_LINE_ACHIEVED   11
#define OPEN_ARCHIVE_IN_NEW_WINDOW         12
#define PASTE_FILES_ACHIEVED               13
#define SCAN_ACHIEVED                      14
#define WIZARD_ACHIEVED                    15
#define UNSPLIT_ACHIEVED                   16
#define SPLIT_ACHIEVED                     17


#define UNKNOWN -1
#define TAR     2
#define TARGZ   4
#define TARBZ2  8
#define ZIP     16
#define GZIP    32
#define BZIP2   64
#define RAR     128
#define LHA     256
#define ARJ     512
#define SEVENZ  1024
#define AR      2048
#define SIT     4096
#define HQX     8192
#define CRYPTED 16384

#endif // RESOURCE_H
